"use strict";
exports.__esModule = true;
function asyncWriter(stream) {
    var draining = true;
    function doWrite(chunk) {
        return new Promise(function (resolve, reject) {
            if (draining) {
                draining = stream.write(chunk, function (err) {
                    if (err) {
                        reject(err);
                    }
                    else {
                        resolve();
                    }
                });
            }
            else {
                stream.once('drain', function () {
                    // await recursive
                    doWrite(chunk)
                        .then(resolve)["catch"](reject);
                });
            }
        });
    }
    return doWrite;
}
exports.asyncWriter = asyncWriter;
