"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var child_process_1 = require("child_process");
var path = require("path");
var util = require("util");
Object.prototype.dump = function () {
    return util.inspect(this, {
        depth: null,
        maxArrayLength: null,
        breakLength: 0
    });
};
String.prototype.camelCase = function () {
    return this.toLowerCase()
        .replace(/-(.)/g, function (match, group1) {
        return group1.toUpperCase();
    });
};
String.prototype.underscore = function () {
    return this.replace(/([A-Z])/g, function (m) { return '_' + m.toLowerCase(); });
};
function indexById(types) {
    var ret = {};
    types.forEach(function (type) {
        ret[type.sys.id] = type;
    });
    return ret;
}
exports.indexById = indexById;
function indexByContentType(items) {
    var ret = {};
    items.forEach(function (item) {
        ret[item.sys.contentType.sys.id] = item;
    });
    return ret;
}
exports.indexByContentType = indexByContentType;
function wait(ms) {
    return new Promise(function (resolve, reject) {
        setTimeout(function () { return resolve(); }, ms);
    });
}
exports.wait = wait;
function formatFile(file) {
    var tsFmtBinLocation = path.join(require.resolve('typescript-formatter'), '../../.bin/tsfmt');
    var tsfmtConfigFile = path.relative(process.cwd(), path.join(__dirname, '../tsfmt.json'));
    return new Promise(function (resolve, reject) {
        child_process_1.exec(tsFmtBinLocation + " -r " + file + " --useTsfmt " + tsfmtConfigFile, function (err, stdout, stderr) {
            if (err) {
                reject(err.message + '\n\t' + stderr);
            }
            else {
                resolve();
            }
        });
    });
}
exports.formatFile = formatFile;
function eachInSequence(items, op) {
    return __awaiter(this, void 0, void 0, function () {
        var ret, i, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    ret = [];
                    i = 0;
                    _c.label = 1;
                case 1:
                    if (!(i < items.length)) return [3 /*break*/, 4];
                    _b = (_a = ret).push;
                    return [4 /*yield*/, op(items[i], i, items)];
                case 2:
                    _b.apply(_a, [_c.sent()]);
                    _c.label = 3;
                case 3:
                    i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, ret];
            }
        });
    });
}
exports.eachInSequence = eachInSequence;
